//*****************************************************************************
//*****************************************************************************
//  FILENAME:     cmx_dio_chan.h
//   Version:     1.0.0
//
//  DESCRIPTION: 
//    Header file for cmx_dio_chan.asm
//
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef DIO_CHAN_include
#define DIO_CHAN_include

#include <m8c.h>

#pragma fastcall16 DiscreteDriveMode 
#pragma fastcall16 DiscreteReadPin
#pragma fastcall16 GlobalSelectDisconnect
#pragma fastcall16 GlobalSelectConnect
#pragma fastcall16 SetPin
#pragma fastcall16 DISetPin

//extern  void  DiscreteDriveMode(BYTE bpin, BYTE bport);

extern  void  DiscreteDriveMode(BYTE bpin, BYTE bport,BYTE bdrivemode);
extern  BYTE  DiscreteReadPin(BYTE bpin, BYTE bport);
extern  void  GlobalSelectDisconnect(BYTE bpin, BYTE bport);
extern  void  GlobalSelectConnect(BYTE bpin, BYTE bport);
extern  void  SetPin(BYTE bPortPin, BYTE bValue);
extern  void  DISetPin(BYTE bPortPin, BYTE bValue);

extern  const BYTE DIOChannelPins[];
extern  const BYTE portlu[];
extern  const BYTE pinlu[];
 

#endif
