	cpu LMM
	.module tablelookup.c
	.area text(rom, con, rel)
	.dbfile ./tablelookup.c
	.dbfunc e TableLookup _TableLookup fc
; inputInstanceID -> X+9
;        nRetVal -> X+8
;   nLookUpIndex -> X+7
;    tableParams -> X+1
;         nIndex -> X+0
;      pParamBlk -> X-5
_TableLookup::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 11
; //
; //  TableLookup.c
; //
; #include "CMXSystem.h"
; #include "CMXSystemFunction.h"
; #include "CMXSystemExtern.h"
; #include "FunctionParamDecl.h"
; #include "TableLookup.h"
; 
; BYTE TableLookup( TABLE_LOOKUP_PB const * pParamBlk)
; {
	.dbline 12
; 	BYTE nRetVal = 0;
	mov [X+8],0
	.dbline 18
; 	BYTE nIndex;
; 	BYTE nLookUpIndex;
; 	BYTE inputInstanceID;
; 	
; 	// get the parameter block
; 	TABLE_LOOKUP_PB tableParams = *pParamBlk;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov [__r3],X
	add [__r3],1
	mov REG[0xd5],7
	push X
	mov [__rX],0
	mov X,[__r1]
X0:
	push A
	romx
	mov REG[0xd0],>__r0
	mvi [__r3],A
	pop A
	inc X
	adc A,0
	inc [__rX]
	cmp [__rX],6
	jnz X0
	pop X
	.dbline 20
; 	// calculate lookup value
; 	nLookUpIndex = 0;
	mov [X+7],0
	.dbline 21
; 	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	mov [X+0],0
	xjmp L15
L12:
	.dbline 22
	.dbline 23
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	asl [__r1]
	rlc [__r0]
	mov A,[X+2]
	add [__r1],A
	mov A,[X+1]
	adc [__r0],A
	mov A,[__r1]
	add A,2
	mov [__r3],A
	mov A,[__r0]
	adc A,0
	push X
	push A
	mov X,[__r3]
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r3],A
	pop X
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov [__r0],0
	mov [__rX],0
	mov [__rY],0
X1:
	cmp [__r0],0
	jnz X4
	cmp [__r1],0
	jz X3
X4:
	and F,-5
	rrc [__r0]
	rrc [__r1]
	jnc X2
	mov REG[0xd0],>__r0
	mov A,[__r3]
	add [__rX],A
	mov A,[__r2]
	adc [__rY],A
X2:
	asl [__r3]
	rlc [__r2]
	jmp X1
X3:
	mov [__r1],[__rX]
	mov REG[0xd0],>__r0
	mov A,[X+7]
	add A,[__r1]
	mov [X+7],A
	.dbline 24
L13:
	.dbline 21
	inc [X+0]
L15:
	.dbline 21
	mov A,[X+0]
	cmp A,[X+5]
	jc L12
X5:
	.dbline 25
; 	{
; 		nLookUpIndex += *(tableParams.InputList[nIndex].pInputVar) * tableParams.InputList[nIndex].multiplier;
; 	}
; 	if (nLookUpIndex < tableParams.LookUpTableSize)
	mov A,[X+7]
	cmp A,[X+6]
	jnc L17
X6:
	.dbline 26
; 	{
	.dbline 28
; 		// set output value
; 		nRetVal = (tableParams.LookUpTable)[nLookUpIndex];
	mov REG[0xd0],>__r0
	mov A,[X+7]
	mov [__r1],A
	mov [__r0],0
	mov A,[X+4]
	add [__r1],A
	mov A,[X+3]
	adc [__r0],A
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+8],A
	.dbline 29
; 	}
L17:
	.dbline 31
; 	
; 	return nRetVal;
	mov A,[X+8]
	mov REG[0xd0],>__r0
	.dbline -2
L11:
	add SP,-10
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l inputInstanceID 9 c
	.dbsym l nRetVal 8 c
	.dbsym l nLookUpIndex 7 c
	.dbsym l tableParams 1 X
	.dbsym l nIndex 0 c
	.dbsym l pParamBlk -5 pX
	.dbend
