//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_PULSELED.h
//   Version: 1.0.0.2, Updated on 2006/08/01 at 15:25:26
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for the PULSELED Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#ifndef `@LIB_NAME`_PULSELED_include
#define `@LIB_NAME`_PULSELED_include

#include <M8C.h>

`@PULSELED_ORDINAL_DEFINE_BLOCK`
#define `@LIB_NAME`_PULSELED_COUNT `@PULSELED_COUNT`
////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
    BYTE PULSELED_ID;					// Instance ID
    BYTE PULSELED_ChannelID;			// Channel ID
    unsigned int uLED_Decay_Grow_Time;	// Time to decay or grow LED intensivity
}`@LIB_NAME`_PULSELED_ParameterBlock;

// Function Prototypes
void `@LIB_NAME`_PULSELED_SetValue(const `@LIB_NAME`_PULSELED_ParameterBlock * thisBLK, BYTE bState);
void `@LIB_NAME`_PULSELED_Instantiate(const `@LIB_NAME`_PULSELED_ParameterBlock * thisBLK);


#endif
