//----------------------------------------------------------------------------
// DriverDecl.c
//----------------------------------------------------------------------------

#include "DriverDecl.h"
#include "CMXSystemExtern.h"

const CMX_GSWITCH_ParameterBlock pse_Button0 = { ID_pse_Button0, GSWITCH_pse_Button0_ORDINAL, 0x01, 0x00, ID_DIO_14};
const CMX_DIO_ParameterBlock pse_LED_OnOff = { ID_pse_LED_OnOff, 0x01, 0x01, 0x01 ,0x00, ID_DIO_22};
const CMX_BLINKINGLED_ParameterBlock pse_LED_Blink = { ID_pse_LED_Blink, 0x01, 0x01, 32 ,BLINKINGLED_pse_LED_Blink_ORDINAL, ID_DIO_23};
const CMX_PULSELED_ParameterBlock pse_LED_Decay = { PULSELED_pse_LED_Decay_ORDINAL, ID_PWM_00, 2000>>4};

void * const DriverParams[] =
{
	(void *)0,	// ID = 0
	(void *)&pse_Button0, // ID = 1
	(void *)&pse_LED_OnOff, // ID = 2
	(void *)&pse_LED_Blink, // ID = 3
	(void *)&pse_LED_Decay, // ID = 4
		// ID_MAX = 5
};
