//
//  FunctionParamDecl.c
//
//     function parameter block declarations

// individual function includes
#include "FunctionParamDecl.h"
#include "SystemConst.h"
#include "SystemVars.h"
#include "CMXSystemExtern.h"

// function parameter declarations
// pse_LED_Blink_TableLookup parameter declarations
TABLE_LOOKUP_INPUT const pse_LED_Blink_TableLookup_InputList[pse_LED_Blink_TableLookup_InputList_COUNT] =
{
	{&SystemVars.ReadOnlyVars.pse_Button0, 1},

};

BYTE const pse_LED_Blink_TableLookup_LookupTable[pse_LED_Blink_TableLookup_LookupTable_COUNT] = 
{
	ID_pse_LED_Blink_ON, // output value for input value = 000
	ID_pse_LED_Blink_BLINKING, // output value for input value = 001

};

TABLE_LOOKUP_PB const pse_LED_Blink_TableLookup =
{
	{pse_LED_Blink_TableLookup_InputList},
	{pse_LED_Blink_TableLookup_LookupTable},
	pse_LED_Blink_TableLookup_InputList_COUNT,
	pse_LED_Blink_TableLookup_LookupTable_COUNT
};
// pse_LED_Decay_TableLookup parameter declarations
TABLE_LOOKUP_INPUT const pse_LED_Decay_TableLookup_InputList[pse_LED_Decay_TableLookup_InputList_COUNT] =
{
	{&SystemVars.ReadOnlyVars.pse_Button0, 1},

};

BYTE const pse_LED_Decay_TableLookup_LookupTable[pse_LED_Decay_TableLookup_LookupTable_COUNT] = 
{
	ID_pse_LED_Decay_GROW_ON, // output value for input value = 000
	ID_pse_LED_Decay_DECAY_OFF, // output value for input value = 001

};

TABLE_LOOKUP_PB const pse_LED_Decay_TableLookup =
{
	{pse_LED_Decay_TableLookup_InputList},
	{pse_LED_Decay_TableLookup_LookupTable},
	pse_LED_Decay_TableLookup_InputList_COUNT,
	pse_LED_Decay_TableLookup_LookupTable_COUNT
};
// pse_LED_OnOff_TableLookup parameter declarations
TABLE_LOOKUP_INPUT const pse_LED_OnOff_TableLookup_InputList[pse_LED_OnOff_TableLookup_InputList_COUNT] =
{
	{&SystemVars.ReadOnlyVars.pse_Button0, 1},

};

BYTE const pse_LED_OnOff_TableLookup_LookupTable[pse_LED_OnOff_TableLookup_LookupTable_COUNT] = 
{
	ID_pse_LED_OnOff_OFF, // output value for input value = 000
	ID_pse_LED_OnOff_ON, // output value for input value = 001

};

TABLE_LOOKUP_PB const pse_LED_OnOff_TableLookup =
{
	{pse_LED_OnOff_TableLookup_InputList},
	{pse_LED_OnOff_TableLookup_LookupTable},
	pse_LED_OnOff_TableLookup_InputList_COUNT,
	pse_LED_OnOff_TableLookup_LookupTable_COUNT
};

// general function parameter block array
void * const FunctionParams[] =
{
	(void *)0,	// ID = 0
	(void *)&pse_LED_Blink_TableLookup, // ID = 1
	(void *)&pse_LED_Decay_TableLookup, // ID = 2
	(void *)&pse_LED_OnOff_TableLookup, // ID = 3
		// ID_MAX = 4
};
