//
// FunctionParamDecl.h
//

#ifndef FUNCTION_PARAMDECL_H
#define FUNCTION_PARAMDECL_H

#include <m8c.h>
#include "CMXSystemFunction.h"

// function parameter block ID's
#define ID_pse_LED_Blink_TableLookup 1
#define ID_pse_LED_Decay_TableLookup 2
#define ID_pse_LED_OnOff_TableLookup 3

// system variable value defines
// pse_Button0 output state ID defines
#define ID_pse_Button0_Off 0
#define ID_pse_Button0_On 1
#define ID_pse_Button0_UNASSIGNED 255


// pse_Button0 output state value defines
#define ID_pse_Button0_Off_VALUE 0
#define ID_pse_Button0_On_VALUE 1
#define ID_pse_Button0_UNASSIGNED_VALUE 0

// pse_LED_Blink output state ID defines
#define ID_pse_LED_Blink_OFF 0
#define ID_pse_LED_Blink_ON 1
#define ID_pse_LED_Blink_BLINKING 2
#define ID_pse_LED_Blink_UNASSIGNED 255


// pse_LED_Blink output state value defines
#define ID_pse_LED_Blink_OFF_VALUE 0
#define ID_pse_LED_Blink_ON_VALUE 1
#define ID_pse_LED_Blink_BLINKING_VALUE 2
#define ID_pse_LED_Blink_UNASSIGNED_VALUE 0

// pse_LED_Decay output state ID defines
#define ID_pse_LED_Decay_DECAY_OFF 0
#define ID_pse_LED_Decay_GROW_ON 1
#define ID_pse_LED_Decay_UNASSIGNED 255


// pse_LED_Decay output state value defines
#define ID_pse_LED_Decay_DECAY_OFF_VALUE 0
#define ID_pse_LED_Decay_GROW_ON_VALUE 1
#define ID_pse_LED_Decay_UNASSIGNED_VALUE 0

// pse_LED_OnOff output state ID defines
#define ID_pse_LED_OnOff_OFF 0
#define ID_pse_LED_OnOff_ON 1
#define ID_pse_LED_OnOff_UNASSIGNED 255


// pse_LED_OnOff output state value defines
#define ID_pse_LED_OnOff_OFF_VALUE 0
#define ID_pse_LED_OnOff_ON_VALUE 1
#define ID_pse_LED_OnOff_UNASSIGNED_VALUE 0


// system variable value defines for expressions
// pse_Button0 output state ID defines for expressions
#define pse_Button0__Off ID_pse_Button0_Off_VALUE
#define pse_Button0__On ID_pse_Button0_On_VALUE
#define pse_Button0__UNASSIGNED ID_pse_Button0_UNASSIGNED_VALUE

// pse_LED_Blink output state ID defines for expressions
#define pse_LED_Blink__OFF ID_pse_LED_Blink_OFF_VALUE
#define pse_LED_Blink__ON ID_pse_LED_Blink_ON_VALUE
#define pse_LED_Blink__BLINKING ID_pse_LED_Blink_BLINKING_VALUE
#define pse_LED_Blink__UNASSIGNED ID_pse_LED_Blink_UNASSIGNED_VALUE

// pse_LED_Decay output state ID defines for expressions
#define pse_LED_Decay__DECAY_OFF ID_pse_LED_Decay_DECAY_OFF_VALUE
#define pse_LED_Decay__GROW_ON ID_pse_LED_Decay_GROW_ON_VALUE
#define pse_LED_Decay__UNASSIGNED ID_pse_LED_Decay_UNASSIGNED_VALUE

// pse_LED_OnOff output state ID defines for expressions
#define pse_LED_OnOff__OFF ID_pse_LED_OnOff_OFF_VALUE
#define pse_LED_OnOff__ON ID_pse_LED_OnOff_ON_VALUE
#define pse_LED_OnOff__UNASSIGNED ID_pse_LED_OnOff_UNASSIGNED_VALUE


// function parameter block definitions
#define pse_LED_Blink_TableLookup_InputList_COUNT 1
#define pse_LED_Blink_TableLookup_LookupTable_COUNT 2
#define pse_LED_Decay_TableLookup_InputList_COUNT 1
#define pse_LED_Decay_TableLookup_LookupTable_COUNT 2
#define pse_LED_OnOff_TableLookup_InputList_COUNT 1
#define pse_LED_OnOff_TableLookup_LookupTable_COUNT 2

#endif
