//
//  TableLookup.h
//

#ifndef TABLE_LOOKUP_H
#define TABLE_LOOKUP_H

typedef struct
{
	BYTE * pInputVar;
	int multiplier;
} TABLE_LOOKUP_INPUT;

typedef struct
{
	TABLE_LOOKUP_INPUT const * InputList;
	BYTE const * LookUpTable;
	BYTE InputListCount;
	BYTE LookUpTableSize;
} TABLE_LOOKUP_PB;

BYTE TableLookUp( TABLE_LOOKUP_PB const *);

#endif
