//*****************************************************************************
//*****************************************************************************
//  FILENAME:  `@LIB_NAME`_BlinkingLed.h
//  Version: 1.0, Updated on 2006/08/01 at 15:19:24 
//  Application: PSoC Express 2.0
//
//  DESCRIPTION:  Header file for the BlinkingLed Driver
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#ifndef `@LIB_NAME`_BlinkingLed_include
#define `@LIB_NAME`_BlinkingLed_include
#include "cmx_dio_chan.h" 
#include <M8C.h>

`@BLINKINGLED_ORDINAL_DEFINE_BLOCK`
#define `@LIB_NAME`_BLINKINGLED_COUNT `@BLINKINGLED_COUNT`

////////////////////////////////////////////////////////////////////////////////////////////
// parameter block
typedef struct
{
    BYTE BLINKINGLED_ID;              // Instance ID
    BYTE BLINKINGLED_DRIVESENSE;
    BYTE BLINKINGLED_INITIALSTATE;
    BYTE BLINKINGLED_BlinkRate;       // 0 to 100
    BYTE BLINKINGLED_INSTANCE;
    BYTE BLINKINGLED_ChannelID;
}`@LIB_NAME`_BLINKINGLED_ParameterBlock;

//*********************
// Function Prototypes
//*********************
void `@LIB_NAME`_BLINKINGLED_SetValue(const CMX_BLINKINGLED_ParameterBlock * pPBlock, BYTE bValue);
void `@LIB_NAME`_BLINKINGLED_Instantiate(const CMX_BLINKINGLED_ParameterBlock * pPBlock);

#endif
