;@CMX_FRAG_KEYWORDS
TABLELOOKUP_PARAMETER_INITIALIZER
TABLELOOKUP_PARAMETER_DEFINE
TABLELOOKUP_INCLUDE
TABLELOOKUP_LookupTable_OutpuStateARRAYORDINAL_INITIALIZER
TABLELOOKUP_InputList_LookUpInputARRAYORDINAL_INITIALIZER
TABLELOOKUP_FUNCTION_CALL
TABLELOOKUP_FUNCTION_EXTERN
TABLELOOKUP_SIMULATION_CODE
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_PARAMETER_INITIALIZER
	// `@TABLELOOKUP` parameter declarations
	var `@TABLELOOKUP`_InputList = new Array();

`@TABLELOOKUP_InputList_LookupInputARRAYORDINAL_INITIALIZER_BLOCK`

	var `@TABLELOOKUP`_LookupTable = new Array();

`@TABLELOOKUP_LookupTable_OutpuStateARRAYORDINAL_INITIALIZER_BLOCK`

	g_`@TABLELOOKUP`_PB.InputList = `@TABLELOOKUP`_InputList;
	g_`@TABLELOOKUP`_PB.LookUpTable = `@TABLELOOKUP`_LookupTable;
	g_`@TABLELOOKUP`_PB.InputListCount = g_`@TABLELOOKUP`_InputList_COUNT;
	g_`@TABLELOOKUP`_PB.LookUpTableCount = g_`@TABLELOOKUP`_LookupTable_COUNT;

	g_FunctionParams[g_ID_`@TABLELOOKUP`] = g_`@TABLELOOKUP`_PB;
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_LookupTable_OutpuStateARRAYORDINAL_INITIALIZER
	`@TABLELOOKUP`_LookupTable[ARRAYSIMORDINAL] = g_ID_VARIABLE_`@TABLELOOKUP_LookupTable_OutputStateARRAYORDINAL`;
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_InputList_LookupInputARRAYORDINAL_INITIALIZER
	var `@TABLELOOKUP`inputSetupElemARRAYORDINAL = {};
	`@TABLELOOKUP`inputSetupElemARRAYORDINAL.InputVarID = g_ID_`@TABLELOOKUP_InputList_LookupInputARRAYORDINAL_instanceID`;
	`@TABLELOOKUP`inputSetupElemARRAYORDINAL.multiplier = `@TABLELOOKUP_InputList_LookupInputARRAYORDINAL_multiplier`;
	`@TABLELOOKUP`_InputList[ARRAYSIMORDINAL] = `@TABLELOOKUP`inputSetupElemARRAYORDINAL;

;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_PARAMETER_DEFINE
var g_`@TABLELOOKUP`_InputList_COUNT = `@TABLELOOKUP_InputList_COUNT`;
var g_`@TABLELOOKUP`_LookupTable_COUNT = `@TABLELOOKUP_LookupTable_COUNT`;
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_INCLUDE
#include "TableLookup.h"
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_FUNCTION_CALL
TableLookup(g_ID_`@TABLELOOKUP`)
;@CMX_SEGMENT_END

;@CMX_FRAG_TABLELOOKUP_SIMULATION_CODE
function TableLookup( instanceID)
{
	var nRetVal = 0;
	var nIndex;
	var nLookUpIndex;
	var inputInstanceID;
	
	// get the pointer to the parameter block
	var tableParams = g_FunctionParams[instanceID];
	// calculate lookup value
	nLookUpIndex = 0;
	for (nIndex = 0;nIndex < tableParams.InputListCount;nIndex++)
	{
		var inputIndex = tableParams.InputList[nIndex].InputVarID;
		var currentValue = g_CurrentValues[inputIndex];
		var multiplier = tableParams.InputList[nIndex].multiplier;

//		alert ("Input " + nIndex + " inputindex = " + inputIndex + " currentValue = " + currentValue + " multiplier = " + multiplier);
		nLookUpIndex += currentValue * multiplier;
	}
	if (nLookUpIndex < tableParams.LookUpTableCount)
	{
		// set output value
		nRetVal = tableParams.LookUpTable[nLookUpIndex];
	}
	
	return nRetVal;
}

;@CMX_SEGMENT_END
